'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Pin = exports.Wrap = exports.Carton = exports.Container = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockBase = function (_React$Component) {
  _inherits(BlockBase, _React$Component);

  function BlockBase() {
    _classCallCheck(this, BlockBase);

    return _possibleConstructorReturn(this, (BlockBase.__proto__ || Object.getPrototypeOf(BlockBase)).apply(this, arguments));
  }

  _createClass(BlockBase, [{
    key: 'render',
    value: function render() {
      var inline = this.props.inline || {};
      var eventFunc = this.props.eventFunc || {};

      if (this.props.origin && inline.position !== 'absolute') inline.position = 'relative';

      if (this.props.mode === 'normal') {
        switch (this.props.mainAxis) {
          case 'flex-start':
            inline.textAlign = 'left';
            break;
          case 'flex-end':
            inline.textAlign = 'right';
            break;
          case 'flex-center':
            inline.textAlign = 'center';
            break;
        }
      } else {
        inline.display = 'flex';
        if (this.props.mode === 'flex-row') inline.flexDirection = 'row';
        if (this.props.mode === 'flex-column') inline.flexDirection = 'column';
        if (this.props.mainAxis) inline.justifyContent = this.props.mainAxis;
        if (this.props.crossAxis) inline.alignItems = this.props.crossAxis;
      }

      if (this.props.overflow) inline.overflow = this.props.overflow;
      if (this.props.hidden) inline.display = 'none';

      inline.lineHeight = 1;

      return _react2.default.createElement(
        'div',
        _extends({
          className: this.props.external,
          style: inline
        }, eventFunc),
        this.props.children
      );
    }
  }]);

  return BlockBase;
}(_react2.default.Component);

BlockBase.propsType = {
  mode: _react2.default.PropTypes.oneOf(['flex-row', 'flex-column', 'normal']),
  overflow: _react2.default.PropTypes.string,
  mainAxis: _react2.default.PropTypes.string,
  crossAxis: _react2.default.PropTypes.string,
  hidden: _react2.default.PropTypes.bool,
  origin: _react2.default.PropTypes.bool,
  external: _react2.default.PropTypes.string,
  inline: _react2.default.PropTypes.object,
  eventFunc: _react2.default.PropTypes.object
};

BlockBase.defaultProps = {
  mode: 'normal',
  origin: false,
  hidden: false
};

var Container = function Container(_ref) {
  var _ref$autoHeight = _ref.autoHeight,
      autoHeight = _ref$autoHeight === undefined ? false : _ref$autoHeight,
      props = _objectWithoutProperties(_ref, ['autoHeight']);

  var inline = props.inline || {};
  inline.width = '100%';
  if (!autoHeight) inline.height = '100%';

  return _react2.default.createElement(BlockBase, _extends({ inline: inline }, props));
};

var Carton = function Carton(_ref2) {
  var _ref2$width = _ref2.width,
      width = _ref2$width === undefined ? 'auto' : _ref2$width,
      _ref2$height = _ref2.height,
      height = _ref2$height === undefined ? 'auto' : _ref2$height,
      _ref2$fixed = _ref2.fixed,
      fixed = _ref2$fixed === undefined ? false : _ref2$fixed,
      props = _objectWithoutProperties(_ref2, ['width', 'height', 'fixed']);

  var inline = props.inline || {};
  inline.width = width;
  inline.height = height;

  if (fixed) inline.flex = '0 0 auto';

  return _react2.default.createElement(BlockBase, _extends({ inline: inline }, props));
};

var Wrap = BlockBase;

var Pin = function Pin(_ref3) {
  var top = _ref3.top,
      bottom = _ref3.bottom,
      left = _ref3.left,
      right = _ref3.right,
      _ref3$index = _ref3.index,
      index = _ref3$index === undefined ? 0 : _ref3$index,
      _ref3$width = _ref3.width,
      width = _ref3$width === undefined ? 'auto' : _ref3$width,
      _ref3$height = _ref3.height,
      height = _ref3$height === undefined ? 'auto' : _ref3$height,
      props = _objectWithoutProperties(_ref3, ['top', 'bottom', 'left', 'right', 'index', 'width', 'height']);

  var inline = props.inline || {};
  if (top) inline.top = top;
  if (bottom) inline.bottom = bottom;
  if (left) inline.left = left;
  if (right) inline.right = right;

  inline.position = 'absolute';
  inline.width = width;
  inline.height = height;
  inline.zIndex = index;

  return _react2.default.createElement(BlockBase, _extends({ inline: inline }, props));
};

exports.Container = Container;
exports.Carton = Carton;
exports.Wrap = Wrap;
exports.Pin = Pin;