'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Layout = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ReactCSP = require('../util/ReactCSP');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Layout = exports.Layout = function (_React$Component) {
  _inherits(Layout, _React$Component);

  function Layout(props) {
    _classCallCheck(this, Layout);

    var _this = _possibleConstructorReturn(this, (Layout.__proto__ || Object.getPrototypeOf(Layout)).call(this, props));

    _this.state = { scroll: 0 };

    _this.handleScroll = _this.handleScroll.bind(_this);
    return _this;
  }

  _createClass(Layout, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.chan) {
        this.props.chan(_ReactCSP.trigger.component(this, function (prevProps, prevState) {
          if (_this2.state.scroll !== prevState.scroll) {
            return { path: 'react-layer-layout.layout/' + _this2.props.label, type: 'data', preload: { scroll: _this2.state.scroll } };
          }
        }));
      }
    }
  }, {
    key: 'handleScroll',
    value: function handleScroll(evt) {
      this.setState({ scroll: evt.target.scrollTop });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        {
          className: 'place-' + this.props.label + ' ' + this.props.external,
          onScroll: this.handleScroll,
          style: {
            position: 'absolute',
            top: this.props.top,
            left: this.props.left,
            width: this.props.width,
            height: this.props.height,
            overflow: this.props.overflow,
            zIndex: this.props.zIndex
          }
        },
        this.props.children
      );
    }
  }]);

  return Layout;
}(_react2.default.Component);

Layout.propTypes = {
  external: _react2.default.PropTypes.string,
  top: _react2.default.PropTypes.number,
  left: _react2.default.PropTypes.number,
  overflow: _react2.default.PropTypes.string,
  zIndex: _react2.default.PropTypes.number,
  chan: _react2.default.PropTypes.func,
  width: _react2.default.PropTypes.number.isRequired,
  height: _react2.default.PropTypes.number.isRequired,
  label: _react2.default.PropTypes.string.isRequired
};

Layout.defaultProps = {
  top: 0,
  left: 0,
  overflow: 'inherit',
  zIndex: 0
};