'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Article = exports.Message = exports.Phrase = exports.TextBase = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextBase = exports.TextBase = function (_React$Component) {
  _inherits(TextBase, _React$Component);

  function TextBase() {
    _classCallCheck(this, TextBase);

    return _possibleConstructorReturn(this, (TextBase.__proto__ || Object.getPrototypeOf(TextBase)).apply(this, arguments));
  }

  _createClass(TextBase, [{
    key: 'render',
    value: function render() {
      var inline = this.props.inline || {};
      var eventFunc = this.props.eventFunc || {};

      if (this.props.block) inline.display = 'inline-block';
      if (this.props.nowrap) inline.whiteSpace = 'nowrap';
      if (this.props.pre) inline.whiteSpace = 'pre-wrap';
      if (this.props.pre && this.props.nowrap) inline.whiteSpace = 'pre';

      return _react2.default.createElement(
        'span',
        _extends({
          className: this.props.external,
          style: inline
        }, eventFunc),
        this.props.children
      );
    }
  }]);

  return TextBase;
}(_react2.default.Component);

TextBase.propTypes = {
  external: _react2.default.PropTypes.string,
  inline: _react2.default.PropTypes.object,
  eventFunc: _react2.default.PropTypes.object,
  nowrap: _react2.default.PropTypes.bool,
  block: _react2.default.PropTypes.bool,
  pre: _react2.default.PropTypes.bool
};

TextBase.defaultProps = {
  external: null,
  block: false,
  nowrap: false,
  pre: false
};

var Phrase = function Phrase(_ref) {
  var _ref$size = _ref.size,
      size = _ref$size === undefined ? '14px' : _ref$size,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? '#414141' : _ref$color,
      _ref$align = _ref.align,
      align = _ref$align === undefined ? 'left' : _ref$align,
      _ref$weight = _ref.weight,
      weight = _ref$weight === undefined ? 'normal' : _ref$weight,
      _ref$decoration = _ref.decoration,
      decoration = _ref$decoration === undefined ? 'none' : _ref$decoration,
      _ref$inline = _ref.inline,
      inline = _ref$inline === undefined ? {} : _ref$inline,
      props = _objectWithoutProperties(_ref, ['size', 'color', 'align', 'weight', 'decoration', 'inline']);

  inline.lineHeight = 1;
  inline.fontSize = size;
  inline.fontWeight = weight;
  inline.decoration = decoration;
  inline.color = color;
  inline.textAlign = align;

  return _react2.default.createElement(TextBase, _extends({ inline: inline }, props));
};

var Message = function Message(_ref2) {
  var _ref2$size = _ref2.size,
      size = _ref2$size === undefined ? '14px' : _ref2$size,
      _ref2$color = _ref2.color,
      color = _ref2$color === undefined ? '#414141' : _ref2$color,
      _ref2$weight = _ref2.weight,
      weight = _ref2$weight === undefined ? 'normal' : _ref2$weight,
      _ref2$align = _ref2.align,
      align = _ref2$align === undefined ? "left" : _ref2$align,
      _ref2$line = _ref2.line,
      line = _ref2$line === undefined ? "1.7" : _ref2$line,
      _ref2$width = _ref2.width,
      width = _ref2$width === undefined ? "auto" : _ref2$width,
      _ref2$inline = _ref2.inline,
      inline = _ref2$inline === undefined ? {} : _ref2$inline,
      props = _objectWithoutProperties(_ref2, ['size', 'color', 'weight', 'align', 'line', 'width', 'inline']);

  inline.lineHeight = 1;
  inline.fontSize = size;
  inline.fontWeight = weight;
  inline.lineHeight = line;
  inline.color = color;
  inline.textAlign = align;
  inline.width = width;

  return _react2.default.createElement(TextBase, _extends({ inline: inline }, props));
};

var Article = function Article() {
  // Markdown, JSON render
};

exports.Phrase = Phrase;
exports.Message = Message;
exports.Article = Article;