import React from 'react'

export class Image extends React.Component {
  render() {
    const inline = this.props.inline || {}
    const eventFunc  = this.props.eventFunc || {}

    inline.objectFit = 'contain'
    inline.width = this.props.width
    inline.height = this.props.height
    if (!inline.verticalAlign) inline.verticalAlign = 'bottom'
    if (this.props.mode) inline.objectFit = this.props.mode

    return (
      <img
        className={this.props.external}
        style={inline}
        src={this.props.src}
        alt={ this.props.alt || this.props.src }
        { ...eventFunc }
      />
    )
  }
}

Image.propTypes = {
  external: React.PropTypes.string,
  inline: React.PropTypes.object,
  eventFunc: React.PropTypes.object,
  src: React.PropTypes.string.isRequired,
  alt: React.PropTypes.string,
  width: React.PropTypes.string,
  height: React.PropTypes.string,
  mode: React.PropTypes.oneOf(['cover', 'contain']),
}

Image.defaultProps = {
  width: 'auto',
  height: 'auto',
}
