import React from 'react'
import _ from 'lodash'

export class Surface extends React.Component {
  constructor(props) {
    super(props)

    this.state = {
      width: window.innerWidth,
      height: window.innerHeight,
    }

    this.reRenderChildrenComponent = this.reRenderChildrenComponent.bind(this)
  }

  componentDidMount() {
    window.addEventListener('resize', () => {
      this.setState({ width: window.innerWidth, height: window.innerHeight })
    })
  }

  reRenderChildrenComponent() {
    const width = this.state.width
    const height = this.state.height

    if (_.isArray(this.props.children))
      return _.map(this.props.children, (child, i) => React.cloneElement(child, { width, height, key: i }))
    else {
      return React.cloneElement(this.props.children, { width, height })
    }
  }

  render() {
    return (
    <div>
      { this.reRenderChildrenComponent() }
    </div>
    )
  }
}
